#/usr/bin/env python

import os
import sys
import traceback
import subprocess

from settings import Settings
from baseConfigurationStep import BaseConfigurationStep

class NedeployInstall(BaseConfigurationStep):
    def __init__(self):
        pass

    def process(self, environment):
        node_public_ip  = environment['node_public_ip']
        node_type       = environment['node_type']
        replicast_eth   = environment['replicast_eth']
        nodocker        = environment['nodocker']
        profile         = environment['profile']
        exclude         = environment['exclude']
        reserved        = environment['reserved']

        print('[{}]'.format(self.__class__.__name__))
        print("\tnode_public_ip : {}".format(node_public_ip))
        print("\tnode_type      : {}".format(node_type))
        print("\treplicast_eth  : {}".format(replicast_eth))
        print("\tnodocker       : {}".format(nodocker))
        print("\tprofile        : {}".format(profile))
        print("\texclude        : {}".format(exclude))
        print("\treserved       : {}".format(reserved))

        try:

            neadmCmd = [Settings.NEDEPLOY_CMD, 'deploy', 'solo',  node_public_ip, 'nexenta:nexenta', '-i', replicast_eth]

            if node_type == 'mgmt':
                neadmCmd.append('-m')
            elif node_type == 'gateway':
                #ADD GATEWAY parameter to deploy solo cmd
                print("Gateway type selected!! ")

            #profile section 
            neadmCmd.append('-t')
            if profile.lower() == 'balanced':
                neadmCmd.append('balanced')
            elif profile.lower() == 'performance':
                neadmCmd.append('performance')
            else:
                neadmCmd.append('capacity')

            if nodocker and nodocker == True:
                neadmCmd.append('--nodocker')
           
            if exclude:
                neadmCmd.append('-x')
                neadmCmd.append(exclude)
        
            if reserved:
                neadmCmd.append('-X')
                neadmCmd.append(reserved)

            print("NEDEPLOY cmd is: {0}".format(' '.join(neadmCmd)))
            output = subprocess.check_output(neadmCmd)

        except Exception as ex:
            raise Exception('in {0}\nMessage:{1}\nTrace: {2}'.format(self.__class__.__name__, ex.message, traceback.format_exc()))
